<?php
/*
@package wp-solar
@internal  General settings
@since 0.1
@todo nothing
*/

if ( ! defined( 'ABSPATH' ) ) { 
    exit;
}

function wp_solar_options_page() {
	$menu_entry = __( 'WP Solar', 'wp-solar' );
	add_options_page( __( 'WP Solar Options', 'wp-solar' ), $menu_entry, 'manage_options', 'wp-solar', 'wp_solar_options_page_html');
}

function wp_solar_options_page_html() {
	echo '<div class="wrap">';
	echo '<table>';
	echo '<tr><td colspan="2"><h1>'. __( 'WP Solar Options', 'wp-solar' ).'</h1></td></tr>';
	echo '<form method="post" action="options.php">';

	settings_fields( 'wp-solar' );
	echo '<tr><td colspan="2"><h2>'. __( 'SolarEdge API', 'wp-solar' ).'</h2></td></tr>';
	echo '<tr><td valign="top"><label for="wp_solar_solaredge_api_keys">'. __( 'SolarEdge API keys and Site IDs (comma separated, one per line)', 'wp-solar' ).' </td><td><textarea name="wp_solar_solaredge_api_keys" rows="15" cols="80">'. get_option( 'wp_solar_solaredge_api_keys' ) .'</textarea></label></td></tr>';

	echo '<tr><td colspan="2"><h2>'. __( 'Display settings', 'wp-solar' ).'</h2></td></tr>';
	echo '<tr><td><label for="wp_solar_power_display_units">'. __( 'Power display units', 'wp-solar' ).' </td><td><select name="wp_solar_power_display_units"><option value="Wh" ' . selected( 'Wh', get_option( 'wp_solar_power_display_units' ), false ) . '>'.__( 'Wh', 'wp-solar' ).'</option><option value="kWh" ' . selected( 'kWh', get_option( 'wp_solar_power_display_units' ), false ) . '>'.__( 'kWh', 'wp-solar' ).'</option><option value="MWh" ' . selected( 'MWh', get_option( 'wp_solar_power_display_units' ), false ) . '>'.__( 'MWh', 'wp-solar' ).'</option><option value="GWh" ' . selected( 'GWh', get_option( 'wp_solar_power_display_units' ), false ) . '>'.__( 'GWh', 'wp-solar' ).'</option><option value="TWh" ' . selected( 'TWh', get_option( 'wp_solar_power_display_units' ), false ) . '>'.__( 'TWh', 'wp-solar' ).'</option></select></label></td></tr>';
	echo '<tr><td><label for="wp_solar_power_display_color">'. __( 'Power display color', 'wp-solar' ).' </td><td><input name="wp_solar_power_display_color" type="text" id="wp_solar_power_display_color" value="'. get_option( 'wp_solar_power_display_color' ) .'" size="80" /></label></td></tr>';
	echo '<tr><td><label for="wp_solar_annual_power_display_colors">'. __( 'Annual power display colors', 'wp-solar' ).' </td><td><input name="wp_solar_annual_power_display_colors" type="text" id="wp_solar_annual_power_display_colors" value="'. get_option( 'wp_solar_annual_power_display_colors' ) .'" size="80" /></label></td></tr>';

	echo '<tr><td colspan="2"><h2>'. __( 'CO2 saved', 'wp-solar' ).'</h2></td></tr>';
	echo '<tr><td><label for="wp_solar_co2_conversion">'. __( 'CO2 conversion', 'wp-solar' ).' </td><td><input name="wp_solar_co2_conversion" type="text" id="wp_solar_co2_conversion" value="'. get_option( 'wp_solar_co2_conversion' ) .'" size="80" /></label> g per kWh</td></tr>';
	echo '<tr><td><label for="wp_solar_co2_display_units">'. __( 'Saved CO2 display units', 'wp-solar' ).' </td><td><select name="wp_solar_co2_display_units"><option value="kg" ' . selected( 'kg', get_option( 'wp_solar_co2_display_units' ), false ) . '>'.__( 'kg', 'wp-solar' ).'</option><option value="T" ' . selected( 'T', get_option( 'wp_solar_co2_display_units' ), false ) . '>'.__( 'T', 'wp-solar' ).'</option><option value="kT" ' . selected( 'kT', get_option( 'wp_solar_co2_display_units' ), false ) . '>'.__( 'kT', 'wp-solar' ).'</option></select></label></td></tr>';
	echo '<tr><td colspan="2">';
	submit_button();
	echo '</td></tr>';
	echo '</form>';
	echo '</div>';
}

function wp_solar_register_settings() {
	register_setting( 'wp-solar', 'wp_solar_solaredge_api_keys' );
	register_setting( 'wp-solar', 'wp_solar_power_display_units' );
	register_setting( 'wp-solar', 'wp_solar_power_display_color', 'wp_solar_options_sanitize_text_field' );
	register_setting( 'wp-solar', 'wp_solar_annual_power_display_colors', 'wp_solar_options_sanitize_text_field' );
	register_setting( 'wp-solar', 'wp_solar_co2_conversion', 'wp_solar_options_sanitize_text_field' );
	register_setting( 'wp-solar', 'wp_solar_co2_display_units' );
}

function wp_solar_options_sanitize_text_field( $input ) {
	$input = sanitize_text_field( $input );
	return $input;
}