<?php
/*
@package wp-solar
@internal  Create shortcodes
@since 0.1
@todo nothing
*/

if ( ! defined( 'ABSPATH' ) ) { 
    exit;
}

function wp_solar_power_units_shortcode() {
	$power_units = get_option( 'wp_solar_power_display_units' );
	return $power_units;
}
add_shortcode( 'wp_solar_power_units', 'wp_solar_power_units_shortcode' );

/* ----------------------------------------------- */

function wp_solar_last_update_shortcode( $atts ) {
	$last_update = get_transient( 'wp_solar_update' );
	if ( isset( $atts['timezone'] ) )
		date_default_timezone_set( $atts['timezone'] );
	if ( isset( $atts['setlocale'] ) )
		setlocale(LC_ALL, $atts['setlocale']);
	if ( isset( $atts['format'] ) )
		$last_update = date( $atts['format'], $last_update );
	return $last_update;
}
add_shortcode( 'wp_solar_last_update', 'wp_solar_last_update_shortcode' );

/* ----------------------------------------------- */

function wp_solar_total_power_shortcode( $atts ) {
	$wp_solar_production = get_transient( 'wp_solar_production' );
	$power_divider = wp_solar_get_power_divider();
	$wp_solar_total_power = number_format_i18n( $wp_solar_production / $power_divider, 2 );
	return $wp_solar_total_power;
}
add_shortcode( 'wp_solar_total_power', 'wp_solar_total_power_shortcode' );

/* ----------------------------------------------- */

function wp_solar_power_graph_shortcode( $atts ) {
	if ( false === ( $wp_solar_power_graph = get_transient( 'wp_solar_power_graph' )))
		return ( __( 'No data available yet', 'wp-solar' ) );
	else
		return $wp_solar_power_graph;
}

add_shortcode( 'wp_solar_power_graph', 'wp_solar_power_graph_shortcode' );

/* ----------------------------------------------- */

function wp_solar_annual_power_graph_shortcode( $atts ) {
	if ( false === ( $wp_solar_annual_power_graph = get_transient( 'wp_solar_annual_power_graph' )))
		return ( __( 'No data available yet', 'wp-solar' ) );
	else
		return $wp_solar_annual_power_graph;
}

add_shortcode( 'wp_solar_annual_power_graph', 'wp_solar_annual_power_graph_shortcode' );

/* ----------------------------------------------- */

function wp_solar_annual_power_graph_per_site_shortcode( $atts ) {
	if ( false === ( $wp_solar_annual_power_graph_per_site = get_transient( 'wp_solar_annual_power_graph_per_site' )))
		return ( __( 'No data available yet', 'wp-solar' ) );
	else
		return $wp_solar_annual_power_graph_per_site;
}

add_shortcode( 'wp_solar_annual_power_graph_per_site', 'wp_solar_annual_power_graph_per_site_shortcode' );

/* ----------------------------------------------- */

function wp_solar_home_conversion_shortcode() {
	if ( get_option( 'wp_solar_co2_conversion' ) != false ) {
		$wp_solar_production = get_transient( 'wp_solar_production' );
		$wp_solar_co2_conversion = get_option( 'wp_solar_co2_conversion' );
		if ( get_option( 'wp_solar_co2_display_units' ) == 'kg' )
			$co2_saved = number_format_i18n( $wp_solar_co2_conversion * $wp_solar_production / 1000 / 1000, 2);
		if ( get_option( 'wp_solar_co2_display_units' ) == 'T' )
			$co2_saved = number_format_i18n( $wp_solar_co2_conversion * $wp_solar_production / 1000 / 1000000, 2);
		if ( get_option( 'wp_solar_co2_display_units' ) == 'kT' )
			$co2_saved = number_format_i18n( $wp_solar_co2_conversion * $wp_solar_production / 1000 / 1000000000, 2);
		return $co2_saved;
	}
}
add_shortcode( 'wp_solar_home_conversion', 'wp_solar_home_conversion_shortcode' );

/* ----------------------------------------------- */

function wp_solar_co2_saved_shortcode() {
	if ( get_option( 'wp_solar_co2_conversion' ) != false ) {
		$wp_solar_production = get_transient( 'wp_solar_production' );
		$wp_solar_co2_conversion = get_option( 'wp_solar_co2_conversion' );
		if ( get_option( 'wp_solar_co2_display_units' ) == 'kg' )
			$co2_saved = number_format_i18n( $wp_solar_co2_conversion * $wp_solar_production / 1000 / 1000, 2);
		if ( get_option( 'wp_solar_co2_display_units' ) == 'T' )
			$co2_saved = number_format_i18n( $wp_solar_co2_conversion * $wp_solar_production / 1000 / 1000000, 2);
		if ( get_option( 'wp_solar_co2_display_units' ) == 'kT' )
			$co2_saved = number_format_i18n( $wp_solar_co2_conversion * $wp_solar_production / 1000 / 1000000000, 2);
		return $co2_saved;
	}
}
add_shortcode( 'wp_solar_co2_saved', 'wp_solar_co2_saved_shortcode' );

/* ----------------------------------------------- */

function wp_solar_co2_units_shortcode() {
	$co2_units = get_option( 'wp_solar_co2_display_units' );
	return $co2_units;
}
add_shortcode( 'wp_solar_co2_units', 'wp_solar_co2_units_shortcode' );

/* ----------------------------------------------- */

